
###     ,      .
###   ,   ... :)         
###       .    90%,   
###      .     prof.conf,
### ..        5   ,   4.
###
### P.S.    -,    . :)))
### by Twin (  :])

###      
proc mc:gainlevel {id} {
    global mc mcs prof race

    mc:setstat level $id [expr [mc:getstat level $id] + 1]
    mc:logn [ms:dfl [mc:getstat nick $id]] "Get new level: [mc:getstat level $id]"

    mc:setstat str  $id [expr [mc:getstat rstr $id] + [lindex $race([mc:getstat race $id]) 1]  + [lindex $prof([mc:getstat prof $id]) 8]]
    mc:setstat dex  $id [expr [mc:getstat rdex $id] + [lindex $race([mc:getstat race $id]) 2]  + [lindex $prof([mc:getstat prof $id]) 9]]
    mc:setstat wis  $id [expr [mc:getstat rwis $id] + [lindex $race([mc:getstat race $id]) 3]  + [lindex $prof([mc:getstat prof $id]) 10]]
    mc:setstat int  $id [expr [mc:getstat rint $id] + [lindex $race([mc:getstat race $id]) 4]  + [lindex $prof([mc:getstat prof $id]) 11]]
    mc:setstat con  $id [expr [mc:getstat rcon $id] + [lindex $race([mc:getstat race $id]) 5]  + [lindex $prof([mc:getstat prof $id]) 12]]

    ### mc:addfree  ,     ,     .
    mc:setstat free $id [expr [mc:getstat free $id] + [lindex $prof([mc:getstat prof $id]) 13] + [mc:addfree [mc:getstat remort $id] [mc:getstat level $id]]]

    mc:setstat skp  $id [expr [mc:getstat skp $id] + 3]
}

proc mc:mremort {n uh h t} {
    global mc mcs ct race prof thicoll records

    set id [mc:makeid $n]

    if {![mc:check $id 0]} { return }

    if {[mc:getstat level $id] < 10} {
        mc:msg $n $ct(remort1)
        return
    }

    ###    
    mc:addsave $id "auto-save: remort #[expr [mc:getstat remort $id] + 1]"

    mc:setstat remort $id [expr [mc:getstat remort $id] + 1]
    mc:setstat level $id 1
    mc:setstat exp $id 0
    mc:setstat eset $id 0
    mc:setstat skp $id 0

    mc:setstat str  $id [expr ($mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 1]) + [lindex $race([mc:getstat race $id]) 1] + [lindex $prof([mc:getstat prof $id]) 1] + [mc:getstat remort $id]]
    mc:setstat dex  $id [expr ($mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 2]) + [lindex $race([mc:getstat race $id]) 2] + [lindex $prof([mc:getstat prof $id]) 2] + [mc:getstat remort $id]]
    mc:setstat wis  $id [expr ($mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 3]) + [lindex $race([mc:getstat race $id]) 3] + [lindex $prof([mc:getstat prof $id]) 3] + [mc:getstat remort $id]]
    mc:setstat int  $id [expr ($mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 4]) + [lindex $race([mc:getstat race $id]) 4] + [lindex $prof([mc:getstat prof $id]) 4] + [mc:getstat remort $id]]
    mc:setstat con  $id [expr ($mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 5]) + [lindex $race([mc:getstat race $id]) 5] + [lindex $prof([mc:getstat prof $id]) 5] + [mc:getstat remort $id]]

    mc:setstat free $id [expr [lindex $prof([mc:getstat prof $id]) 13] + [mc:addfree [mc:getstat remort $id] [mc:getstat level $id]]]

    mc:setstat hbase $id [lindex $prof([mc:getstat prof $id]) 6]
    mc:setstat bonus $id 0
    mc:setstat skill $id [lindex $prof([mc:getstat prof $id]) 15]
    mc:setstat magic $id [lindex $prof([mc:getstat prof $id]) 16]

    ###    
    set profnum 0
    switch -- [mc:getstat prof $id] {
        l { set profnum 1 }
        m { set profnum 2 }
        p { set profnum 3 }
        w { set profnum 4 }
    }
    set records($profnum) [mc:recordremort $records($profnum) [mc:getstat remort $id] $id]
    mc:saverecords

    ###     
    set gold [mc:getstat gold $id]
    set neweq ""
    set changeeq 0
    putlog "Not delete stuff >= [expr 750 * [mc:getstat remort $id]] price"
    foreach e [mc:getstat eq $id] {
        set wremort 0
        if { [mc:wget [lindex $e 1] remort $id] != 0 } {
            set wremort 1
        } else {
            foreach coll [array names thicoll] {
                if { [mc:incoll [lindex $e 0] $coll] && [mc:fullcoll $id $coll noeq] && [mc:wgetcoll $coll remort] != 0 } {
                    set wremort 1
                    break
                }
            }
        }
        if { $wremort != 0 || [mc:wget [lindex $e 1] price $id] >= [expr 750 * [mc:getstat remort $id]] } {
            set e [lreplace $e 2 2 0]
            set e [lreplace $e 3 3 -]
            set neweq [lappend neweq $e]
        } else {
            set changeeq 1
            incr gold [mc:wget [lindex $e 1] price $id]
        }
    }

    ###   
    set newinv ""
    set changeinv 0
    foreach e [mc:getstat inv $id] {
        putlog "e == $e"
        if { $e == "{- -}" } { continue }
        ###      - 
        if { [mc:wgettal [lindex $e 0] remort] != 1 } {
            set newinv [lappend newinv $e]
        } else {
            set changeinv 1
        }
    }

    ###  50%    
#    set gold [expr2 0 $gold * 0.50]

    if { $neweq != "" } {
        for {set i 0} {$i < [llength $neweq]} {incr i} {
            set neweq [lreplace $neweq $i $i [lreplace [lindex $neweq $i] 1 1 [expr $i + 1]]]
        }
    }
    set neweq "{waa 0 1 a {}} $neweq"
    mc:setstat eq $id "$neweq"
    mc:setstat wield $id "- -"

    #set newinv "{- -} $newinv"
    mc:setstat inv $id "$newinv"

    mc:setstat gold $id [expr2 0 $gold + [lindex $prof([mc:getstat prof $id]) 7]]

    mc:msg $n [format $ct(remort2) [expr 1 + [mc:getstat remort $id]]][mc:gethark $id]

    set new ""
    if { $changeeq  == 1 } { set new [lappend new $ct(remorte)] }
    if { $changeinv == 1 } { set new [lappend new $ct(remortt)] }
    if { $new != "" } {
        set new [join $new "  "]
        mc:msg $n [format $ct(remortn) $new]
    }
}

proc mc:nostat {n uh h t} {
    global mc mcs prof race

    if { ![mc:ismaster $h] } { return }

    mc:nlog $h $t
    set ee [mc:makeid [lindex $t 1]]
    set lev [mc:getstat level $ee]
    mc:setstat str  $ee [expr [lindex $prof([mc:getstat prof $ee]) 1] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 1]) + [lindex $race([mc:getstat race $ee]) 1] * $lev + [lindex $prof([mc:getstat prof $ee]) 8]  * ($lev - 1) + [mc:getstat remort $ee]]
    mc:setstat dex  $ee [expr [lindex $prof([mc:getstat prof $ee]) 2] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 2]) + [lindex $race([mc:getstat race $ee]) 2] * $lev + [lindex $prof([mc:getstat prof $ee]) 9]  * ($lev - 1) + [mc:getstat remort $ee]]
    mc:setstat wis  $ee [expr [lindex $prof([mc:getstat prof $ee]) 3] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 3]) + [lindex $race([mc:getstat race $ee]) 3] * $lev + [lindex $prof([mc:getstat prof $ee]) 10] * ($lev - 1) + [mc:getstat remort $ee]]
    mc:setstat int  $ee [expr [lindex $prof([mc:getstat prof $ee]) 4] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 4]) + [lindex $race([mc:getstat race $ee]) 4] * $lev + [lindex $prof([mc:getstat prof $ee]) 11] * ($lev - 1) + [mc:getstat remort $ee]]
    mc:setstat con  $ee [expr [lindex $prof([mc:getstat prof $ee]) 5] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 5]) + [lindex $race([mc:getstat race $ee]) 5] * $lev + [lindex $prof([mc:getstat prof $ee]) 12] * ($lev - 1) + [mc:getstat remort $ee]]

    mc:setstat free $ee [expr [lindex $prof([mc:getstat prof $ee]) 13] * $lev + [mc:addfree [mc:getstat remort $ee] $lev $lev]]

    set neweq ""
    foreach item [mc:getstat eq $ee] {
        set item [lreplace $item 2 2 0]
        set item [lreplace $item 3 3 -]
        set neweq [lappend neweq $item]
    }
    mc:setstat eq $ee "$neweq"
    mc:setstat eset $ee 0

    mc:log "Reset STATS for [mc:getstat nick $ee] - done"
    mc:msg $n "reset STATS for [mc:getstat nick $ee] - done"
}

proc mc:updatestat {n uh h t} {
    global mc mcs mco prof race

    if { ![mc:ismaster $h] } { return }

    if { [llength $t] < 5 } {
        mc:msg $n "Format: !updatestats <races> <profs> <minlevel> <minremort>"
        return
    }
    mc:nlog $h $t
    set races [mc:allrace]
    if { [lindex $t 1] != "-" } { set races [lindex $t 1] }
    set profs [mc:allprof]
    if { [lindex $t 2] != "-" } { set profs [lindex $t 2] }
    set minlevel 1
    if { [lindex $t 3] != "-" } { set minlevel [lindex $t 3] }
    set minremort 0
    if { [lindex $t 4] != "-" } { set minremort [lindex $t 4] }

    putlog "Update STATS by $n... Races: $races, Profs: $profs, MinLevel: $minlevel, MinRemort: $minremort"

    foreach ee [array names mcs] {
        set lev [mc:getstat level $ee]

        if { ![mc:checkin [mc:getstat race $ee] $races] } { continue }
        if { ![mc:checkin [mc:getstat prof $ee] $profs] } { continue }
        if { [mc:getstat level $ee]  < $minlevel }  { continue }
        if { [mc:getstat remort $ee] < $minremort } { continue }

        mc:setstat str  $ee [expr [lindex $prof([mc:getstat prof $ee]) 1] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 1]) + [lindex $race([mc:getstat race $ee]) 1] * $lev + [lindex $prof([mc:getstat prof $ee]) 8]  * ($lev - 1) + [mc:getstat remort $ee]]
        mc:setstat dex  $ee [expr [lindex $prof([mc:getstat prof $ee]) 2] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 2]) + [lindex $race([mc:getstat race $ee]) 2] * $lev + [lindex $prof([mc:getstat prof $ee]) 9]  * ($lev - 1) + [mc:getstat remort $ee]]
        mc:setstat wis  $ee [expr [lindex $prof([mc:getstat prof $ee]) 3] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 3]) + [lindex $race([mc:getstat race $ee]) 3] * $lev + [lindex $prof([mc:getstat prof $ee]) 10] * ($lev - 1) + [mc:getstat remort $ee]]
        mc:setstat int  $ee [expr [lindex $prof([mc:getstat prof $ee]) 4] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 4]) + [lindex $race([mc:getstat race $ee]) 4] * $lev + [lindex $prof([mc:getstat prof $ee]) 11] * ($lev - 1) + [mc:getstat remort $ee]]
        mc:setstat con  $ee [expr [lindex $prof([mc:getstat prof $ee]) 5] + ($mc(raceharkbonus) * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 5]) + [lindex $race([mc:getstat race $ee]) 5] * $lev + [lindex $prof([mc:getstat prof $ee]) 12] * ($lev - 1) + [mc:getstat remort $ee]]

        mc:setstat free $ee [expr [lindex $prof([mc:getstat prof $ee]) 13] * $lev + [mc:addfree [mc:getstat remort $ee] $lev $lev]]

        set neweq ""
        foreach item [mc:getstat eq $ee] {
            set item [lreplace $item 2 2 0]
            set item [lreplace $item 3 3 -]
            set neweq [lappend neweq $item]
        }
        mc:setstat eq $ee "$neweq"
        mc:setstat eset $ee 0
    }
    mc:msg $n "  ."
    putlog "Done."
}

proc mc:harksok {e id} {
    global mc thi race prof

    if { [llength $e] > 1 } {
        set wid [lindex $e 0]
    } else {
        set wid $e
    }

    if { [info exist thi($wid)] } {
        set ps [mc:getstat str $id]
        set pl [mc:getstat dex $id]
        set pm [mc:getstat wis $id]
        set pi [mc:getstat int $id]
        set pv [mc:getstat con $id]

        if { [llength $e] > 1 } {
            set harks [mc:wget [lindex $e 1] hark $id]
        } else {
            set harks [mc:wget $wid hark]
        }

        set mins 0
        set minl 0
        set minm 0
        set mini 0
        set minv 0

        set mins [expr [lindex $harks 0] + $mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 1] + [mc:getstat remort $id] ]
        set minl [expr [lindex $harks 1] + $mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 2] + [mc:getstat remort $id] ]
        set minm [expr [lindex $harks 2] + $mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 3] + [mc:getstat remort $id] ]
        set mini [expr [lindex $harks 3] + $mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 4] + [mc:getstat remort $id] ]
        set minv [expr [lindex $harks 4] + $mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 5] + [mc:getstat remort $id] ]

        if { $ps < $mins } { return 0 }
        if { $pl < $minl } { return 0 }
        if { $pm < $minm } { return 0 }
        if { $pi < $mini } { return 0 }
        if { $pv < $minv } { return 0 }

        return 1
    }
    return 0
}

proc mc:explain {n uh h t} {
    global mc thi cth ct wear ctasll harksfull race prof
    global weapontype weaponweight

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 2 } {
        mc:msg $n $cth(60)
        return
    }
    set mx [lindex [split $t] 1]
    set mid ""
    if { [isnumber $mx] } {
        set mx [expr round($mx)]
        set mid $id
        set iss 1
        foreach nn [mc:getstat eq $id] {
            if { [lindex $nn 1] == $mx } {
                set iss 0
                set realitemid [lindex $nn 0]
                break
            }
        }
        if { $iss } {
            mc:msg $n $cth(61c)
            return
        }
    } else {
        if { ![info exist thi($mx)] } {
            mc:msg $n $cth(61)
            return
        }
        set realitemid $mx
        #if { [mc:getstat gold $id] < [mc:wget $mx price] } {
        #    mc:msg $n $cth(61)
        #    return
        #}
        if { [mc:wget $mx race] != 0 && ![mc:checkin [mc:getstat race $id] [split [mc:wget $mx race] ","]] } {
            mc:msg $n $cth(61)
            return
        }
#        if { [mc:wget $mx prof] != 0 && ![mc:checkin [mc:getstat prof $id] [split [mc:wget $mx prof] ","]] } {
#            mc:msg $n $cth(61)
#            return
#        }
        ###           
        if { [mc:wget $mx shop] == 0 || [mc:checkin "-" [mc:wget $mx shop]] } {
            mc:msg $n $cth(61)
            return
        }
    }

    set out ""
    if { [mc:wget $mx hit $mid] != [mc:wget Default hit] } {
        if { [mc:wget $mx heal $mid] == 1 } {
            set out [lappend out [format $cth(65h) [mc:wget $mx hit $mid]]]
        } else {
            set out [lappend out [format $cth(65) [mc:wget $mx hit $mid]]]
        }
    }
    if { [mc:wget $mx atc $mid] != [mc:wget Default atc] } {
        if { [mc:wget $mx atc $mid] >= 0 } {
            set out [lappend out [format $cth(66) "+[mc:wget $mx atc $mid]"]]
        } else {
            set out [lappend out [format $cth(66) [mc:wget $mx atc $mid]]]
        }
    }
    if { [mc:wget $mx prt $mid] != [mc:wget Default prt] } {
        if { [mc:wget $mx prt $mid] >= 0 } {
            set out [lappend out [format $cth(67) "+[mc:wget $mx prt $mid]"]]
        } else {
            set out [lappend out [format $cth(67) [mc:wget $mx prt $mid]]]
        }
    }

    if { [mc:wget $mx plushark $mid] != [mc:wget Default plushark] } {
        set ph [mc:wget $mx plushark $mid]

        set pstr [lindex $ph 0]
        set pdex [lindex $ph 1]
        set pwis [lindex $ph 2]
        set pint [lindex $ph 3]
        set pcon [lindex $ph 4]

        if { $pstr > 0 } { set pstr "+$pstr" }
        if { $pdex > 0 } { set pdex "+$pdex" }
        if { $pwis > 0 } { set pwis "+$pwis" }
        if { $pint > 0 } { set pint "+$pint" }
        if { $pcon > 0 } { set pcon "+$pcon" }

        if { $pstr != 0 } {
            set out [lappend out "str:03$pstr10"]
        }
        if { $pdex != 0 } {
            set out [lappend out "dex:03$pdex10"]
        }
        if { $pwis != 0 } {
            set out [lappend out "wis:03$pwis10"]
        }
        if { $pint != 0 } {
            set out [lappend out "int:03$pint10"]
        }
        if { $pcon != 0 } {
            set out [lappend out "con:03$pcon10"]
        }
    }

    set mharks [mc:wget $mx hark $mid]
    set mho ""
    set harkn 0
    set parmn 1
    set plrharks(1) [mc:getstat str $id]
    set plrharks(2) [mc:getstat dex $id]
    set plrharks(3) [mc:getstat wis $id]
    set plrharks(4) [mc:getstat int $id]
    set plrharks(5) [mc:getstat con $id]

    foreach hark $mharks {
        set hark [expr $hark + $mc(raceharkbonus) * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) $parmn] + [mc:getstat remort $id]]
        if { $hark > 0 } {
          if {$hark > $plrharks($parmn)} {
            set mho [lappend mho [format $ctasll(2) [lindex $harksfull $harkn] $hark]]
          } else {
            set mho [lappend mho [format $ctasll(3) [lindex $harksfull $harkn] $hark]]
          }
        }
        incr harkn
        incr parmn
    }
    set mho [join $mho "/"]

    set template ""
    set mx2 "!"
    if { [mc:wget $mx child $mid] } {
        ###   ,     
        if {[isnumber $mx]} {
            foreach tmp [mc:getstat eq $id] {
                if {[lindex $tmp 1] == $mx} {
                    set mx2 [lindex $tmp 0]
                }
            }
        }
        set template [format $cth(exte) $mx2 [mc:wget $mx name $mid 0]]
        if { [mc:checkin "-" [mc:wget $mx2 shop]] } { set template "" }
    }

    ### 
    set price [mc:wget $mx price $mid]
    set price " (03${price}g10)"
    if { [mc:checkin "-" [mc:wget $mx shop $mid]] } { set price "" }

    ###  
    set wtype ""
    if { [mc:wget $mx weapon $mid] > 0 && [info exists weapontype([mc:wget $mx weapon $mid])] } {
        set wtype [format $cth(exwp) $weapontype([mc:wget $mx weapon $mid])]
    }
    ###  
    set wweight ""
    if { $wtype != "" && [mc:wget $mx atcmod $mid] > 0 && [info exists weaponweight([mc:wget $mx atcmod $mid])] } {
        set wweight [format $cth(exwe) [lindex $weaponweight([mc:wget $mx atcmod $mid]) 1] [lindex $weaponweight([mc:wget $mx atcmod $mid]) 0]]
    }

    ###  /
    set drainout ""
    set stat [mc:wget $mx drainhit $mid]
    if { $stat != 0 } {
        if { [string first "%" $stat] != -1 } {
            set drainout [lappend drainout [format $cth(exhd) "$stat  "]]
        } else {
            regsub -all "x" $stat "10x03" stat
            set drainout [lappend drainout [format $cth(exhd) $stat]]
        }
    }
    set stat [mc:wget $mx drainmana $mid]
    if { $stat != 0 } {
        if { [string first "%" $stat] != -1 } {
            set drainout [lappend drainout [format $cth(exmd) "$stat  "]]
        } else {
            regsub -all "x" $stat "10x03" stat
            set drainout [lappend drainout [format $cth(exmd) $stat]]
        }
    }
    if { $drainout != "" } {
        set drainout [join $drainout "/"]
    }

    ###  
    set gethpout ""
    set pos [mc:wget $mx gethp $mid]
    if { $pos == 0 } { set pos "" }
    switch -- [lindex $pos 0] {
      0 {
        set pos [lindex $pos 1]
        regsub -all "x" $pos "10x03" pos
        set gethpout [format $cth(exgh) "()03$pos10"]
      }
      1 {
        set pos [lindex $pos 1]
        if { [string first "%" $pos] != -1 } {
          set pos "$pos  "
        } elseif { [string first "x" $pos] } {
          regsub -all "x" $pos "10x03" pos
        }
        set gethpout [format $cth(exgh) "( )03$pos10"]
      }
    }

    ###  
    set getmpout ""
    set pos [mc:wget $mx getmp $mid]
    if { $pos == 0 } { set pos "" }
    switch -- [lindex $pos 0] {
      0 {
        set pos [lindex $pos 1]
        regsub -all "x" $pos "10x03" pos
        set getmpout [format $cth(exgm) "()03$pos10"]
      }
      1 {
        set pos [lindex $pos 1]
        if { [string first "%" $pos] != -1 } {
          set pos "$pos  "
        } elseif { [string first "x" $pos] } {
          regsub -all "x" $pos "10x03" pos
        }
        set getmpout [format $cth(exgm) "( )03$pos10"]
      }
    }

    set stat [mc:wget $mx maxhp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      set maxout "[format $cth(exmxh) $stat]"
    } { set maxout "" }
    set stat [mc:wget $mx maxmp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      if {$maxout!=""} { append maxout "/" }
      append maxout [format $cth(exmxm) $stat]
    }

    set stat [mc:wget $mx reghp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      set regout "[format $cth(exrgh) $stat]"
    } { set regout "" }
    set stat [mc:wget $mx regmp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      if {$regout!=""} { append regout "/" }
      append regout [format $cth(exrgm) $stat]
    }

    if { $mid == "" } {
      set inum ""
    } {
      set inum [format $cth(64.num) $mx]
    }

    set tout ""
    set tout [lappend tout [format $cth(64) $realitemid [mc:wget $mx name $mid] $inum $price $wtype $wweight $template]]
    set tout [lappend tout [format $cth(exbs) [join $out "/"]]]
    if { $mho != "" } { set tout [lappend tout [format $cth(exmh) $mho]] }
    if { $drainout != "" } { set tout [lappend tout "\[$drainout\]"] }
    if { $gethpout != "" } { set tout [lappend tout "\[$gethpout\]"] }
    if { $getmpout != "" } { set tout [lappend tout "\[$getmpout\]"] }
    if { $maxout   != "" } { set tout [lappend tout "\[$maxout\]"] }
    if { $regout   != "" } { set tout [lappend tout "\[$regout\]"] }

    ### 
    set out ""
    if { [mc:wget $mx remort $mid] != 0 } {
        set out [lappend out $cth(exre)]
    }
    if { [mc:wget $mx price $mid] == 0 || [mc:wget $mx nosell $mid] == 1 } {
        set out [lappend out $cth(exse)]
    }
    if { $out != "" } {
        set out [join $out ", "]
        set out "\($out\)"
        set tout [lappend tout $out]
    }
    set tout [join $tout ", "]
    mc:msg $n $tout
}
